# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import langlib
import usermsg
import vecmath
import weaponlib
import gamethread

import os

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "Daggers by L'In20Cible"
g_informations["version"] = "1.3"
g_informations["date"] = "2010-07-15"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/daggers/"
g_informations["basename"] = "daggers"

es.ServerVar((g_informations["basename"] + "_version"), (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_options = {
   "enable": [1, "daggers_enable <1/0> -- Active/Désactive les fonctionnalités du script daggers."],
   "effects": [0, "daggers_effects <1/0> -- Active/Désactive l'effet sur les couteaux lorsqu'ils n'appartiennent à aucun joueur."],
   "friendlyfire": [0, "daggers_friendlyfire <1/0> -- Active/Désactive le tir fraternel."],
   "distance": [750, "daggers_distance <int> -- Définit la distance du lancé."],
   "sounds": [1, "daggers_sounds <1/0> -- Active/Désactive les sons lancés par le script daggers."],
   "damages": [100, "daggers_damages <int> -- Définit la quantité de dommages causés par un couteau lancé."],
   "advert": [1, "daggers_advert <1/0> -- Active/Désactive l'annonce indiquant aux joueurs la touche à utiliser pour lancer leur couteau."]
   }
for option in g_options:
   g_options[option] = es.ServerVar((g_informations["basename"] + "_" + option), g_options[option][0], g_options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   __init__()
   es.addons.registerTickListener(TickListener)
   es.addons.registerClientCommandFilter(ClientCommandFilter)
   
   
def __init__():
   global g_players, g_spammers, g_roundover, g_translations
   g_players, g_spammers = dict(), list()
   g_roundover = False
   path = GetFilePath("configuration.cfg")
   if os.path.isfile(path):
      es.mexec(path.replace(str(es.server_var["eventscripts_gamedir"]).replace(os.sep, "/"), ".."))
   g_translations = TranslationFileIsMissing
   path = GetFilePath("translations.ini")
   if not os.path.isfile(path):
      return
   g_translations = langlib.Strings(path)
   
   
def unload():
   es.addons.unregisterTickListener(TickListener)
   es.addons.unregisterClientCommandFilter(ClientCommandFilter)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetFilePath(file):
   return os.path.join(str(es.server_var["eventscripts_gamedir"]), "cfg", "eventscripts", g_informations["basename"], file).replace(os.sep, "/")
   
   
def GetViewProp(userid):
   returnvalue = -1
   CheatExec(userid, "ent_setname daggers_viewed_prop")
   for index in es.createentitylist():
      targetname = es.entitygetvalue(index, "targetname")
      if (targetname != "daggers_viewed_prop"):
         continue
      returnvalue = index
      es.entitysetvalue(index, "targetname", targetname)
      break
   return returnvalue
   
   
def GetViewPlayer(userid):
   returnvalue = -1
   index = GetViewProp(userid)
   for player in es.getUseridList():
      if (index != es.createplayerlist(player)[player]["index"]):
         continue
      returnvalue = player
      break
   return returnvalue
   
   
def CheatExec(userid, string):
   if not int(es.server_var["sv_cheats"]):
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, string)
      es.forcevalue("sv_cheats", 0)
   else:
      es.server.cmd("es_xsexec %i %s" % (userid, string))
      
      
def GetViewCoord(userid):
   returnvalue = (0.0, 0.0, 0.0)
   entities = es.createentitylist("prop_dynamic")
   CheatExec(userid, "prop_dynamic_create props_c17/tv_monitor01_screen.mdl")
   for index in es.createentitylist("prop_dynamic"):
      if (index in entities):
         continue
      returnvalue = es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")
      RemoveEntity(index)
      break
   return es.createvectorstring(*returnvalue)
   
   
def GetEyeCoord(userid):
   x, y, z = es.getplayerlocation(userid)
   z = (z + 66.7)
   if (es.getplayerprop(userid, "CBasePlayer.localdata.m_Local.m_bDucked") % 2):
      z = (z - 16.1)
   return es.createvectorstring(x, y, z)
   
   
def RemoveEntity(index):
   userid = int(es.getuserid())
   if not es.exists("userid", userid) or (index not in es.createentitylist()) or (es.entitygetvalue(index, "classname") == "worldspawn"):
      return
   es.entitysetvalue(index, "targetname", index)
   es.fire(userid, index, "kill")
   
   
def MakeDamage(userid, attacker):
   if not int(g_options["friendlyfire"]) and (es.getplayerteam(userid) == es.getplayerteam(attacker)):
      return
   es.server.queuecmd("damage %s %s 32 %s" % (userid, int(g_options["damages"]), attacker))
   
   
def GetWeaponIndex(userid, weapon):
   returnvalue = -1
   for index in es.createentitylist(weapon):
      if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != es.getplayerhandle(userid)):
         continue
      returnvalue = index
      break
   return returnvalue
   
   
def GetWeaponCount(userid):
   returnvalue = 0
   for index in es.createentitylist():
      classname = es.entitygetvalue(index, "classname")
      if (classname[:6] != "weapon") or (classname[7:] == "knife") or (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != es.getplayerhandle(userid)):
         continue
      returnvalue = (returnvalue + 1)
   return returnvalue
   
   
# ==================================================
# >> FONCTIONS D'APPELS
# ==================================================


def TickListener():
   if not int(g_options["enable"]):
      return
   if int(g_options["effects"]):
      for index in es.createentitylist("weapon_knife"):
         if (es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") != -1):
            continue
         origin = es.getindexprop(index, "CBaseEntity.m_vecOrigin")
         es.effect("energysplash", origin, origin, 0)
   if not int(g_options["advert"]):
      return
   players = es.createplayerlist()
   for player in players:
      if es.isbot(player):
         continue
      if (player not in g_players):
         g_players[player] = players[player]["weapon"]
      if (g_players[player] != players[player]["weapon"]):
         g_players[player] = players[player]["weapon"]
         if (players[player]["weapon"] != "weapon_knife"):
            continue
         usermsg.hudhint(player, g_translations("advert", dict(), langlib.getLangAbbreviation(es.getclientvar(player, "cl_language"))))
      
      
def ClientCommandFilter(userid, arguments):
   if int(g_options["enable"]) and not g_roundover and (arguments[0].lower() == "drop") and not es.getplayerprop(userid, "CBasePlayer.pl.deadflag") and (es.createplayerlist(userid)[userid]["weapon"] == "weapon_knife") and (userid not in g_spammers):
      g_spammers.append(userid)
      if GetWeaponCount(userid):
         index = GetWeaponIndex(userid, "weapon_knife")
         if (index != -1):
            es.cexec(userid, "lastinv")
            gamethread.delayed(0.2, RemoveEntity, index)
      else:
         es.give(userid, "player_weaponstrip")
         gamethread.delayed(0.2, es.fire, (userid, "player_weaponstrip", "strip"))
      origin = GetEyeCoord(userid)
      target = GetViewPlayer(userid)
      if (target != -1) and (vecmath.distance(origin, es.getplayerlocation(target)) < int(g_options["distance"])):
         gamethread.delayed(0.1, MakeDamage, (target, userid))
      vector = (vecmath.vector(es.createvectorfrompoints(origin, GetViewCoord(userid))) * int(g_options["distance"]))
      index = es.createentity("weapon_knife")
      outputs = {
         "origin"    : origin.replace(",", " "),
         "angles"    : es.createvectorstring(es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[0]"), es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[1]"), 0.0).replace(",", " "),
         "targetname": ("dagger_%i" % index)
         }
      for output in outputs:
         es.entitysetvalue(index, output, outputs[output])
      es.spawnentity(index)
      es.fire(userid, ("dagger_%i" % index), "wake")
      es.delayed(0, "es_xphysics active setvelocity %i %s" % (index, vector))
      if int(g_options["sounds"]):
         es.emitsound("entity", index, "weapons/iceaxe/iceaxe_swing1.wav", 1.0, 0.5)
      gamethread.delayed(1.0, g_spammers.remove, userid)
   return True
   
   
def TranslationFileIsMissing(string, tokens, language):
   return "Sorry, the translations file is missing."
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   __init__()
   
   
def player_spawn(event_var):
   userid = int(event_var["userid"])
   if not int(g_options["enable"]) or (int(event_var["es_userteam"]) not in [2, 3]) or (GetWeaponIndex(userid, "weapon_knife") != -1):
      return
   es.give(userid, "weapon_knife")
   
   
def round_start(event_var):
   global g_roundover
   g_roundover = True
   
def round_freeze_end(event_var):
   global g_roundover
   g_roundover = False
   
   
def player_disconnect(event_var):
   userid = int(event_var["userid"])
   if (userid not in g_players):
      return
   g_players.__delitem__(userid)